(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2000, Lucent Technologies.                               *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: tokens.mli,v 1.20 2002/08/16 00:50:38 simeon Exp $ *)

(* This is only used to debug the lexer - JS *)

open Namespace

(**************)
(* type token *)
(**************)

type xqtoken =
  | Or
  | And
  | Div
  | IDiv
  | Mod
  | Mult
  | Plus
  | Minus
  | Star
  | In
  | Satisfies
  | Return
  | Returns
  | Then
  | CElse
  | To
  | Where
  | Intersect
  | Union
  | Except
  | Before
  | After
  | CCase
  | Instanceof
  | SortBy
  | NCName of string
  | QName of uqname
  | Axis of Xquery_ast.axis
  | Colon
  | ColonColon
  | LtColon
  | Slash
  | SlashSlash
  | Equals
  | EqualsEquals
  | NotEquals
  | NotEqualsEquals
  | ColonEquals
  | Lt
  | Gt
  | LOpeningTag
  | ROpeningTag
  | LClosingTag
  | RClosingTag
  | TextLOpeningTag of string
  | TextLClosingTag of string
  | TextLCurly of string
  | REmptyElement
  | Bar
  | At
  | Lpar
  | Rpar
  | Lbrack
  | Rbrack
  | Lcurly
  | Rcurly
  | Lcurlycurly
  | Rcurlycurly
  | Dollar
  | CSome
  | CEvery
  | CLet
  | CFor
  | CommentLpar
  | TextLpar
  | NodeLpar
  | ProcessingInstructionLpar
  | FunctionNameLpar of uqname
  | If
  | DefineFunction
  | DefineSignature
  | CastAs
  | TreatAs
  | AssertAs
  | Integer of int
  | String of string
  | DescendingT
  | AscendingT
  | SchemaDecl of string
  | TTypeDefn of Namespace.uqname
  | TElementDefn of Namespace.uqname
  | TAttributeDefn of Namespace.uqname
  | TElement
  | TAttribute
  | TType
  | DefineGlobal
  | RAttribute
  | RTextAttribute of Simple._text
  | RAttributeLCurly
  | RTextAttributeLCurly of Simple._text

type tokens = xqtoken list

