(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2000, Lucent Technologies.                               *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xatenv.mli,v 1.3 2002/09/19 00:13:34 simeon Exp $ *)

(* Type environment *)

type tenv

val addvar   : (tenv * Xquery_ast.vname * Xquery_ast.model)                        -> tenv
val addfctn  : (tenv * (Xquery_ast.rfname * int) * Xquery_ast.cfunction_signature) -> tenv

val getvar   : (Finfo.finfo * tenv * Xquery_ast.vname)          -> Xquery_ast.model
val getfctn  : (Finfo.finfo * tenv * (Xquery_ast.rfname * int)) -> Xquery_ast.cfunction_signature

(* Global environment *)

val generate_tenv : Schema.schema -> Xquery_ast.cquery_module -> tenv

val schemaenv     : tenv -> Schema.schema

