type token =
    XQNAME of (Namespace.uqname)
  | XNCNAME of (Simple._ncName)
  | XSTRING of (Simple._string)
  | XMLPI
  | XVERSION
  | XSDDECL
  | XSINGLEQUOTE
  | XDOUBLEQUOTE
  | XDECLNAME of (string)
  | XENCODING of (Conf.encoding_kind)
  | DOCTYPE
  | DOCTYPECLOSE of (string)
  | S
  | LOPENINGTAG
  | LCLOSINGTAG
  | ROPENINGTAG
  | RCLOSINGTAG
  | REMPTYELEMENT
  | TEXTLCLOSINGTAG of (Simple._text)
  | TEXTLOPENINGTAG of (Simple._text)
  | TEXTLCURLY of (Simple._text)
  | OPENINGPI of (Simple._ncName)
  | CLOSINGPI
  | LOPENINGCOMMENT
  | TEXTCLOSINGPI of (Simple._text)
  | TEXTRCLOSINGCOMMENT of (Simple._text)
  | TEXTOPENINGPI of (Simple._text * Simple._ncName)
  | TEXTLOPENINGCOMMENT of (Simple._text)
  | ATTRIBUTETEXT of (Simple._text)
  | ATTRIBUTETEXTLCURLY of (Simple._text)
  | NAMESPACE
  | DECLARENAMESPACE
  | DEFAULTELEMENT
  | DEFAULTFUNCTION
  | DEFINEFUNCTION
  | DEFINESIGNATURE
  | DEFINEGLOBAL
  | IMPORTSCHEMA
  | DEFINETYPE of (Namespace.uqname)
  | DEFINEELEMENT of (Namespace.uqname)
  | DEFINEATTRIBUTE of (Namespace.uqname)
  | DOCUMENTOF
  | ELEMENT
  | ELEMENTOF
  | ATTRIBUTE
  | DOCUMENT
  | TYPE
  | NONE
  | QUESTION
  | NODE
  | ITEM
  | TEXTNODE
  | ATOMIC
  | NUMERIC
  | STABLE
  | ASCENDING
  | DESCENDING
  | EMPTYGREATEST
  | EMPTYLEAST
  | OR
  | AND
  | STAR
  | MULT
  | DIV
  | IDIV
  | MOD
  | MINUS
  | PLUS
  | IN
  | SATISFIES
  | RETURN
  | RETURNS
  | THEN
  | ELSE
  | TO
  | WHERE
  | END
  | INTERSECT
  | UNION
  | EXCEPT
  | PRECEDES
  | FOLLOWS
  | CASE
  | INSTANCEOF
  | DEFAULT
  | IF
  | TYPESWITCH
  | SORTBY
  | ASSERTAS
  | CASTAS
  | TREATAS
  | VALIDATEAS
  | AS
  | SOME
  | EVERY
  | FOR
  | LET
  | NCNAME of (Simple._ncName)
  | QNAME of (Namespace.uqname)
  | AXIS of (Xquery_ast.axis)
  | PROCESSINGINSTRUCTIONLPAR
  | COMMENTLPAR
  | TEXTLPAR
  | NODELPAR
  | COLON
  | LTCOLON
  | BACKSLASHSLASH
  | SLASH
  | SLASHSLASH
  | DOT
  | DOTDOT
  | EQ
  | EQUALS
  | NE
  | NOTEQUALS
  | IS
  | ISNOT
  | LTE
  | GTE
  | LTEQUALS
  | GTEQUALS
  | COLONEQUALS
  | LTOP
  | GTOP
  | LT
  | GT
  | BAR
  | ATSIGN
  | COMMA
  | AMPERSAND
  | SEMICOLON
  | LPAR
  | RPAR
  | RPARLPAR
  | LBRACK
  | RBRACK
  | LCURLY
  | RCURLY
  | DOLLAR
  | FUNCTIONNAMELPAR of (Namespace.uqname)
  | DECIMAL of (Num.num)
  | INT of (Decimal._int)
  | DOUBLE of (float)
  | STRING of (string)
  | EOF

val xml_document :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Xml_ast.xml_document
val test :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Tokens.tokens
val expr :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Xquery_ast.expr
val querymodulelist :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Xquery_ast.query_module_list
